package com.aragost.javahg.commands;

import java.io.File;

import com.aragost.javahg.Repository;
import com.aragost.javahg.commands.flags.RevertCommandFlags;
import com.aragost.javahg.internals.Utils;

public class RevertCommand extends RevertCommandFlags {

    public RevertCommand(Repository repository) {
        super(repository);
    }

    /**
     * Execute with no files. Should be used with {@link #all()}
     */
    public void execute() {
        launchString(new String[0]);
    }

    /**
     * @param files the files to revert.
     */
    public void execute(String...files) {
        launchString(files);
    }

    /**
     * @param files the files to revert.
     */
    public void execute(File... files) {
        execute(Utils.fileArray2StringArray(files));
    }
}
