/*
 * #%L
 * JavaHg
 * %%
 * Copyright (C) 2011 aragost Trifork ag
 * %%
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * #L%
 */

/*
 * Automatically generated based on Mercurial 2.1.1+41-63a1bed65fa3.
 *
 * Don't edit this file! Edit scripts/generate-flag-classes.py instead.
 */
package com.aragost.javahg.commands.flags;

import com.aragost.javahg.Repository;
import com.aragost.javahg.commands.BisectCommand;
import com.aragost.javahg.internals.AbstractCommand;

public abstract class BisectCommandFlags extends AbstractCommand {

    protected BisectCommandFlags(Repository repository) {
        super(repository);
    }

    @Override
    public final String getCommandName() {
        return "bisect";
    }

    public static BisectCommand on(Repository repository) {
        return new BisectCommand(repository);
    }

    /**
     * Set the <tt>--reset</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#bisect">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public BisectCommand reset() {
        cmdAppend("--reset");
        return (BisectCommand) this;
    }

    /**
     * Set the <tt>--good</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#bisect">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public BisectCommand good() {
        cmdAppend("--good");
        return (BisectCommand) this;
    }

    /**
     * Set the <tt>--bad</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#bisect">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public BisectCommand bad() {
        cmdAppend("--bad");
        return (BisectCommand) this;
    }

    /**
     * Set the <tt>--skip</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#bisect">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public BisectCommand skip() {
        cmdAppend("--skip");
        return (BisectCommand) this;
    }

    /**
     * Set the <tt>--extend</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#bisect">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public BisectCommand extend() {
        cmdAppend("--extend");
        return (BisectCommand) this;
    }

    /**
     * Set the <tt>--command</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#bisect">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public BisectCommand command(String cmd) {
        cmdAppend("--command", cmd);
        return (BisectCommand) this;
    }

    /**
     * Set the <tt>--noupdate</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#bisect">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public BisectCommand noupdate() {
        cmdAppend("--noupdate");
        return (BisectCommand) this;
    }

}
