/*
 * #%L
 * JavaHg
 * %%
 * Copyright (C) 2011 aragost Trifork ag
 * %%
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * #L%
 */

/*
 * Automatically generated based on Mercurial 2.1.1+41-63a1bed65fa3.
 *
 * Don't edit this file! Edit scripts/generate-flag-classes.py instead.
 */
package com.aragost.javahg.commands.flags;

import com.aragost.javahg.Repository;
import com.aragost.javahg.commands.ImportCommand;
import com.aragost.javahg.internals.AbstractCommand;

public abstract class ImportCommandFlags extends AbstractCommand {

    protected ImportCommandFlags(Repository repository) {
        super(repository);
    }

    @Override
    public final String getCommandName() {
        return "import";
    }

    public static ImportCommand on(Repository repository) {
        return new ImportCommand(repository);
    }

    /**
     * Set the <tt>--base</tt> command line flag.
     * 
     * @deprecated Using this flag has been deprecated in Mercurial.
     *             The flag wont go away, but there will typically be
     *             a better way to express the same thing.
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#import">Mercurial
     *      documentation</a>
     * @return this instance
     */
    @Deprecated
    public ImportCommand base(String path) {
        cmdAppend("--base", path);
        return (ImportCommand) this;
    }

    /**
     * Set the <tt>--force</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#import">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public ImportCommand force() {
        cmdAppend("--force");
        return (ImportCommand) this;
    }

    /**
     * Set the <tt>--no-commit</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#import">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public ImportCommand noCommit() {
        cmdAppend("--no-commit");
        return (ImportCommand) this;
    }

    /**
     * Set the <tt>--bypass</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#import">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public ImportCommand bypass() {
        cmdAppend("--bypass");
        return (ImportCommand) this;
    }

    /**
     * Set the <tt>--exact</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#import">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public ImportCommand exact() {
        cmdAppend("--exact");
        return (ImportCommand) this;
    }

    /**
     * Set the <tt>--import-branch</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#import">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public ImportCommand importBranch() {
        cmdAppend("--import-branch");
        return (ImportCommand) this;
    }

    /**
     * Set the <tt>--message</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#import">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public ImportCommand message(String text) {
        cmdAppend("--message", text);
        return (ImportCommand) this;
    }

    /**
     * Set the <tt>--date</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#import">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public ImportCommand date(String date) {
        cmdAppend("--date", date);
        return (ImportCommand) this;
    }

    /**
     * Set the <tt>--user</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#import">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public ImportCommand user(String user) {
        cmdAppend("--user", user);
        return (ImportCommand) this;
    }

    /**
     * Set the <tt>--similarity</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#import">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public ImportCommand similarity(String similarity) {
        cmdAppend("--similarity", similarity);
        return (ImportCommand) this;
    }

}
