/*
 * #%L
 * JavaHg
 * %%
 * Copyright (C) 2011 aragost Trifork ag
 * %%
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * #L%
 */

/*
 * Automatically generated based on Mercurial 2.1.1.
 *
 * Don't edit this file! Edit scripts/generate-flag-classes.py instead.
 */
package com.aragost.javahg.commands.flags;

import com.aragost.javahg.Repository;
import com.aragost.javahg.commands.PushCommand;
import com.aragost.javahg.internals.AbstractCommand;

public abstract class PushCommandFlags extends AbstractCommand {

    protected PushCommandFlags(Repository repository) {
        super(repository);
    }

    @Override
    public final String getCommandName() {
        return "push";
    }

    public static PushCommand on(Repository repository) {
        return new PushCommand(repository);
    }

    /**
     * Set the <tt>--force</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#push">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public PushCommand force() {
        cmdAppend("--force");
        return (PushCommand) this;
    }

    /**
     * Set the <tt>--rev</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#push">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public PushCommand rev(String... revs) {
        cmdAppend("--rev", revs);
        return (PushCommand) this;
    }

    /**
     * Set the <tt>--bookmark</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#push">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public PushCommand bookmark(String... bookmarks) {
        cmdAppend("--bookmark", bookmarks);
        return (PushCommand) this;
    }

    /**
     * Set the <tt>--branch</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#push">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public PushCommand branch(String... branches) {
        cmdAppend("--branch", branches);
        return (PushCommand) this;
    }

    /**
     * Set the <tt>--new-branch</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#push">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public PushCommand newBranch() {
        cmdAppend("--new-branch");
        return (PushCommand) this;
    }

    /**
     * Set the <tt>--ssh</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#push">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public PushCommand ssh(String cmd) {
        cmdAppend("--ssh", cmd);
        return (PushCommand) this;
    }

    /**
     * Set the <tt>--remotecmd</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#push">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public PushCommand remotecmd(String cmd) {
        cmdAppend("--remotecmd", cmd);
        return (PushCommand) this;
    }

    /**
     * Set the <tt>--insecure</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#push">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public PushCommand insecure() {
        cmdAppend("--insecure");
        return (PushCommand) this;
    }

}
