package com.aragost.javahg.internals;

import java.io.IOException;
import java.util.Iterator;
import java.util.NoSuchElementException;

public class LineIterator implements Iterator<String>, Iterable<String> {

    private boolean atEnd = false;

    private HgInputStream stream;

    public LineIterator(HgInputStream stream) {
        this.stream = stream;
    }

    public Iterator<String> iterator() {
        return this;
    }

    public boolean hasNext() {
        if (!this.atEnd) {
            try {
                this.atEnd = (this.stream.isEof());
            } catch (IOException e) {
                throw new RuntimeIOException(e);
            }
        }
        return !this.atEnd;
    }

    public String next() {
        if (hasNext()) {
            try {
                return this.stream.textUpTo('\n');
            } catch (IOException e) {
                throw new RuntimeIOException(e);
            }
        } else {
            throw new NoSuchElementException();
        }
    }

    public void remove() {
        throw new UnsupportedOperationException();
    }

}